<template>
  <v-row>
    <v-col>
      <v-form v-if="!form.success" style="max-width: 480px" @submit="sendOrder">
        <v-text-field
          v-model="form.name"
          :error-messages="v$.name.$errors.map(e => e.$message)"
          :counter="10"
          label="Имя"
          required
          variant="solo"
          @input="v$.name.$touch"
          @blur="v$.name.$touch"
        ></v-text-field>
        <v-text-field
          v-model="form.email"
          :error-messages="v$.email.$errors.map(e => e.$message)"
          label="E-mail"
          required
          variant="solo"
          @input="v$.email.$touch"
          @blur="v$.email.$touch"
        ></v-text-field>
        <v-select
          v-model="form.select"
          :items="items"
          :error-messages="v$.select.$errors.map(e => e.$message)"
          label="Город"
          required
          variant="solo"
          @change="v$.select.$touch"
          @blur="v$.select.$touch"
        ></v-select>
        <v-divider></v-divider>
        <v-checkbox
          v-model="form.agreement"
          label="Соглашение с правилами обработки заказа"
          :error-messages="v$.agreement.$errors.map(e => e.$message)"
          @change="v$.agreement.$touch"
          @blur="v$.agreement.$touch"
        ></v-checkbox>
        <v-btn class="me-4" :disabled="v$.$invalid" @click="sendOrder">
          Отправить
        </v-btn>
        <v-btn @click="clear">Очистить</v-btn>
      </v-form>
      <div v-else>Заказ отправлен в обработку</div>
    </v-col>
    {{ form }}
    {{ order }}
  </v-row>
</template>

<script setup>
import { get } from 'vuex-pathify'
import { reactive, ref } from 'vue'
import { useVuelidate } from '@vuelidate/core'
import { email, required } from '@vuelidate/validators'

const order = get('market/order')

const form = reactive({
  name: '',
  email: '',
  select: null,
  agreement: null
})

const items = ref(['Сочи', 'Уфа', 'Москва'])

const rules = {
  name: { required },
  email: { required, email },
  select: { required },
  agreement: { required }
}

const v$ = useVuelidate(rules, form)

function clear() {
  v$.value.$reset()
  for (const [key, value] of Object.entries(form)) {
    form[key] = value
  }
}

function sendOrder() {
  v$.value.$validate()
}
</script>
